Index: pcp/src/wannier.c
===================================================================
--- pcp/src/wannier.c	(revision 9bdd866eca950981175d4eb672952e1c119b1d98)
+++ pcp/src/wannier.c	(revision 4f136930622a3ef24a8e10066443133f1c24c77c)
@@ -313,725 +1330,480 @@
   int start;
   int *rcounts, *rdispls;
-  int AllocNum = ceil((double)Num / 2. ) *2;
-  int totalflag, flag;
-  int *marker, **group;
-  int partner[Num];
-  int type = Occupied;
-  MPI_Comm *comm;
-  char spin[12], suffix[18];
-  
-  N0 = LevS->Plan0.plan->local_nx;
-  N[0] = LevS->Plan0.plan->N[0];
-  N[1] = LevS->Plan0.plan->N[1];
-  N[2] = LevS->Plan0.plan->N[2];
-  
-  comm = &P->Par.comm_ST;
-  
-  fprintf(stderr,"(%i) Comparing groups - AllocNum %i --- All %i\t Psi %i\t PsiT %i\n",P->Par.me, AllocNum, P->Par.Max_me_comm_ST, P->Par.Max_me_comm_ST_Psi, P->Par.Max_my_color_comm_ST_Psi);
-  if (AllocNum % (P->Par.Max_me_comm_ST*2) == 0) {  // all parallel
-    comm = &P->Par.comm_ST;
-    fprintf(stderr,"(%i) Jacobi is done parallely by all\n", P->Par.me);           
-  } else if (P->Par.Max_me_comm_ST_Psi >= P->Par.Max_my_color_comm_ST_Psi) { // always the bigger group comes first  
-    if (AllocNum % (P->Par.Max_me_comm_ST_Psi*2) == 0) {  // coefficients parallel
-      comm = &P->Par.comm_ST_Psi;
-      fprintf(stderr,"(%i) Jacobi is done parallely by Psi\n", P->Par.me);       
-    } else if (AllocNum % (P->Par.Max_my_color_comm_ST_Psi*2) == 0) {  // Psis parallel
-      comm = &P->Par.comm_ST_PsiT;
-      fprintf(stderr,"(%i) Jacobi is done parallely by PsiT\n", P->Par.me);       
-    }
+  double *c, *s;
+  int Lsend, Rsend, Lrecv, Rrecv; // where left(right) column is sent to or where it originates from
+  int left, right; // left or right neighbour for process
+  double spread = 0., old_spread=0., Spread=0.;
+  int i,j,k,l,m,u;
+  int set;
+  int it_steps; // iteration step counter
+  double **Aloc[DiagData->NumMatrices+1], **Uloc; // local columns for one step of A[k]
+  double *Around[DiagData->NumMatrices+1], *Uround; // all local columns for one round of A[k]
+  double *Atotal[DiagData->NumMatrices+1], *Utotal; // all local columns for one round of A[k]
+  double a_i, a_j;
+  gsl_matrix *G;
+  gsl_vector *h;
+  gsl_vector *eval;
+  gsl_matrix *evec;
+  //gsl_eigen_symmv_workspace *w;
+
+  max_rounds = (DiagData->AllocNum / 2)/DiagData->ProcNum;  // each process must perform multiple rotations per step of a set
+  if (P->Call.out[ReadOut]) fprintf(stderr,"(%i) start %i\tstep %i\tmax.rounds %i\n",P->Par.me, DiagData->ProcRank, DiagData->ProcNum, max_rounds);
+  
+  // allocate column vectors for interchange of columns
+  debug(P,"allocate column vectors for interchange of columns");
+  c = (double *) Malloc(sizeof(double)*max_rounds, "ComputeMLWF: c");
+  s = (double *) Malloc(sizeof(double)*max_rounds, "ComputeMLWF: s");
+  c_all = (double *) Malloc(sizeof(double)*DiagData->AllocNum/2, "ComputeMLWF: c_all");
+  s_all = (double *) Malloc(sizeof(double)*DiagData->AllocNum/2, "ComputeMLWF: s_all");
+  rcounts = (int *) Malloc(sizeof(int)*DiagData->ProcNum, "ComputeMLWF: rcounts");
+  rdispls = (int *) Malloc(sizeof(int)*DiagData->ProcNum, "ComputeMLWF: rdispls");
+
+  // allocate eigenvector stuff
+  debug(P,"allocate eigenvector stuff");
+  G = gsl_matrix_calloc (2,2);
+  h = gsl_vector_alloc (2);
+  eval = gsl_vector_alloc (2);
+  evec = gsl_matrix_alloc (2,2);
+  //w = gsl_eigen_symmv_alloc(2);
+  
+  // establish communication partners
+  debug(P,"establish communication partners");
+  if (DiagData->ProcRank == 0) {
+    tagS0 = WannierALTag;   // left p0 always remains left p0
   } else {
-    if (AllocNum % (P->Par.Max_my_color_comm_ST_Psi*2) == 0) {  // Psis parallel 
-      comm = &P->Par.comm_ST_PsiT;
-      fprintf(stderr,"(%i) Jacobi is done parallely by PsiT\n", P->Par.me);       
-    } else if (AllocNum % (P->Par.Max_me_comm_ST_Psi*2) == 0) {  // coefficients parallel
-      comm = &P->Par.comm_ST_Psi;
-      fprintf(stderr,"(%i) Jacobi is done parallely by Psi\n", P->Par.me);       
-    }
-  }
-
-  MPI_Comm_size (*comm, &ProcNum);
-  MPI_Comm_rank (*comm, &ProcRank);
-  
-  if(P->Call.out[StepLeaderOut]) fprintf(stderr,"(%i) Beginning localization of orbitals ...\n",P->Par.me);
-  
-  if(P->Call.out[ReadOut]) fprintf(stderr,"(%i) STEP 2\n",P->Par.me);
-
-  // STEP 2: Calculate A[k]_ij = V/N \sum_{G1,G2} C^\ast_{l,G1} c_{m,G2} \sum_R A^{(k)}(R) exp(iR(G2-G1))
-  gsl_matrix *A[max_operators+1];   // one extra for B matrix
-  for (u=0;u<=max_operators;u++)
-    A[u] = gsl_matrix_calloc (AllocNum,AllocNum);  // allocate matrix    
-
-  // create lookup table for sin/cos values
-  cos_lookup = (double **) Malloc(sizeof(double *)*NDIM, "ComputeMLWF: *cos_lookup");
-  sin_lookup = (double **) Malloc(sizeof(double *)*NDIM, "ComputeMLWF: *sin_lookup");
-  for (i=0;i<NDIM;i++) {
-    // allocate memory
-    cos_lookup[i] = (double *) Malloc(sizeof(double)*LevS->Plan0.plan->N[i], "ComputeMLWF: cos_lookup");
-    sin_lookup[i] = (double *) Malloc(sizeof(double)*LevS->Plan0.plan->N[i], "ComputeMLWF: sin_lookup");
-    // reset arrays
-    SetArrayToDouble0(cos_lookup[i],LevS->Plan0.plan->N[i]);
-    SetArrayToDouble0(sin_lookup[i],LevS->Plan0.plan->N[i]);
-    // create lookup values
-    for (j=0;j<LevS->Plan0.plan->N[i];j++) {
-      tmp = 2*PI/(double)LevS->Plan0.plan->N[i]*(double)j; 
-      cos_lookup[i][j] = cos(tmp);
-      sin_lookup[i][j] = sin(tmp);
-    }
-  }
-  l=-1; // to access U matrix element (0..Num-1)
-  // fill the matrices
-  for (i=0; i < Psi->MaxPsiOfType+P->Par.Max_me_comm_ST_PsiT; i++) {  // go through all wave functions
-    OnePsiA = &Psi->AllPsiStatus[i];    // grab OnePsiA
-    if (OnePsiA->PsiType == type) {   // drop all but occupied ones
-      l++;  // increase l if it is non-extra wave function
-      if (OnePsiA->my_color_comm_ST_Psi == P->Par.my_color_comm_ST_Psi) // local?
-        LPsiDatA=LevS->LPsi->LocalPsi[OnePsiA->MyLocalNo];
-      else
-        LPsiDatA = NULL;  // otherwise processes won't enter second loop, though they're supposed to send coefficients!
-      
-      //fprintf(stderr,"(%i),(%i,%i): fft'd, A[..] and B, back-fft'd acting on \\phi_A\n",P->Par.me,l,0);
-      if (LPsiDatA != NULL) {
-        CalculateOneDensityR(Lat, LevS, Dens0, LPsiDatA, Dens0->DensityArray[ActualDensity], R->FactorDensityR, 1);
-        // note: factor is not used when storing result in DensityCArray[ActualPsiDensity] in CalculateOneDensityR()!
-        for (n0=0;n0<N0;n0++)  
-          for (n[1]=0;n[1]<N[1];n[1]++) 
-            for (n[2]=0;n[2]<N[2];n[2]++) {
-              i0 = n[2]*NUpz+N[2]*NUpz*(n[1]*NUpy+N[1]*NUpy*n0*NUpx);
-              iS = n[2]+N[2]*(n[1]+N[1]*n0);
-              n[0] = n0 + LevS->Plan0.plan->start_nx;
-              for (k=0;k<max_operators;k+=2) {
-                e = k/2;
-                tmp = 2*PI/(double)(N[e])*(double)(n[e]);
-                tmp2 = PsiCR[i0] /LevS->MaxN;
-                // check lookup
-                if (!l) // perform check on first wave function only
-                  if ((fabs(cos(tmp) - cos_lookup[e][n[e]]) > MYEPSILON) || (fabs(sin(tmp) - sin_lookup[e][n[e]]) > MYEPSILON)) {
-                    Error(SomeError, "Lookup table does not match real value!");
-                  }
-                HGcR[k][iS] = cos_lookup[e][n[e]] * tmp2; /* Matrix Vector Mult */
-                HGcR2[k][iS] = cos_lookup[e][n[e]] * HGcR[k][iS]; /* Matrix Vector Mult */
-                HGcR[k+1][iS] = sin_lookup[e][n[e]] * tmp2; /* Matrix Vector Mult */
-                HGcR2[k+1][iS] = sin_lookup[e][n[e]] * HGcR[k+1][iS]; /* Matrix Vector Mult */
-              }
-            }
-        for (u=0;u<max_operators;u++) {
-          fft_3d_real_to_complex(plan, LevS->LevelNo, FFTNF1, HGcRC[u], work);
-          fft_3d_real_to_complex(plan, LevS->LevelNo, FFTNF1, HGcR2C[u], work);
+    tagS0 = (DiagData->ProcRank == DiagData->ProcNum - 1) ? WannierARTag : WannierALTag; // left p_last becomes right p_last          
+  }
+  tagS1 = (DiagData->ProcRank == 0) ? WannierALTag : WannierARTag; // right p0 always goes into left p1
+  tagR0 = WannierALTag; // 
+  tagR1 = WannierARTag; // first process
+  if (DiagData->ProcRank == 0) {
+    left = DiagData->ProcNum-1;
+    right = 1;
+    Lsend = 0;
+    Rsend = 1;
+    Lrecv = 0;
+    Rrecv = 1;        
+  } else if (DiagData->ProcRank == DiagData->ProcNum - 1) {
+    left = DiagData->ProcRank - 1;
+    right = 0;
+    Lsend = DiagData->ProcRank;
+    Rsend = DiagData->ProcRank - 1;
+    Lrecv = DiagData->ProcRank - 1;
+    Rrecv = DiagData->ProcRank;        
+  } else {
+    left = DiagData->ProcRank - 1;
+    right = DiagData->ProcRank + 1;
+    Lsend = DiagData->ProcRank+1;
+    Rsend = DiagData->ProcRank - 1;
+    Lrecv = DiagData->ProcRank - 1;
+    Rrecv = DiagData->ProcRank+1;
+  }
+  //if (P->Call.out[ReadOut]) fprintf(stderr,"(%i) left %i\t right %i --- Lsend %i\tRsend%i\tLrecv %i\tRrecv%i\n",P->Par.me, left, right, Lsend, Rsend, Lrecv, Rrecv);
+  
+  // initialise A_loc
+  debug(P,"initialise A_loc");
+  for (k=0;k<DiagData->NumMatrices+DiagData->extra;k++) {
+    //Aloc[k] = (double *) Malloc(sizeof(double)*AllocNum*2, "ComputeMLWF: Aloc[k]");
+    Around[k] = (double *) Malloc(sizeof(double)*DiagData->AllocNum*2*max_rounds, "ComputeMLWF: Around[k]");
+    Atotal[k] = (double *) Malloc(sizeof(double)*DiagData->AllocNum*DiagData->AllocNum, "ComputeMLWF: Atotal[k]");
+    Aloc[k] = (double **) Malloc(sizeof(double *)*2*max_rounds, "ComputeMLWF: Aloc[k]");
+    //Around[k] = &Atotal[k][ProcRank*AllocNum*2*max_rounds];
+    
+    for (round=0;round<max_rounds;round++) {
+      Aloc[k][2*round] = &Around[k][DiagData->AllocNum*(2*round)];
+      Aloc[k][2*round+1] = &Around[k][DiagData->AllocNum*(2*round+1)];
+      for (l=0;l<DiagData->AllocNum;l++) {
+        Aloc[k][2*round][l] = gsl_matrix_get(DiagData->A[k],l,2*(DiagData->ProcRank*max_rounds+round));
+        Aloc[k][2*round+1][l] = gsl_matrix_get(DiagData->A[k],l,2*(DiagData->ProcRank*max_rounds+round)+1);
+        //fprintf(stderr,"(%i) (%i, 0/1) A_loc1 %e\tA_loc2 %e\n",P->Par.me, l, Aloc[k][l],Aloc[k][l+AllocNum]);
+      }
+    }
+  }
+  // initialise U_loc
+  debug(P,"initialise U_loc");
+  //Uloc = (double *) Malloc(sizeof(double)*AllocNum*2, "ComputeMLWF: Uloc");
+  Uround = (double *) Malloc(sizeof(double)*DiagData->AllocNum*2*max_rounds, "ComputeMLWF: Uround");
+  Utotal = (double *) Malloc(sizeof(double)*DiagData->AllocNum*DiagData->AllocNum, "ComputeMLWF: Utotal");
+  Uloc = (double **) Malloc(sizeof(double *)*2*max_rounds, "ComputeMLWF: Uloc");
+  //Uround = &Utotal[ProcRank*AllocNum*2*max_rounds];
+  for (round=0;round<max_rounds;round++) {
+    Uloc[2*round] = &Uround[DiagData->AllocNum*(2*round)];
+    Uloc[2*round+1] = &Uround[DiagData->AllocNum*(2*round+1)];
+    for (l=0;l<DiagData->AllocNum;l++) {
+      Uloc[2*round][l] = gsl_matrix_get(DiagData->U,l,2*(DiagData->ProcRank*max_rounds+round));
+      Uloc[2*round+1][l] = gsl_matrix_get(DiagData->U,l,2*(DiagData->ProcRank*max_rounds+round)+1);
+      //fprintf(stderr,"(%i) (%i, 0/1) U_loc1 %e\tU_loc2 %e\n",P->Par.me, l, Uloc[l+AllocNum*0],Uloc[l+AllocNum*1]);
+    }
+  }
+  
+  // now comes the iteration loop
+  debug(P,"now comes the iteration loop");
+  it_steps = 0;
+  do {
+    it_steps++;
+    //if (P->Par.me == 0) fprintf(stderr,"(%i) Beginning parallel iteration %i ... ",P->Par.me,it_steps);
+    for (set=0; set < DiagData->AllocNum-1; set++) { // one column less due to column 0 staying at its place all the time
+      //fprintf(stderr,"(%i) Beginning rotation set %i ...\n",P->Par.me,set);
+      for (round = 0; round < max_rounds;round++) {
+        start = DiagData->ProcRank * max_rounds + round;
+        // get indices
+        i = DiagData->top[start] < DiagData->bot[start] ? DiagData->top[start] : DiagData->bot[start]; // minimum of the two indices
+        iloc = DiagData->top[start] < DiagData->bot[start] ? 0 : 1; 
+        j = DiagData->top[start] > DiagData->bot[start] ? DiagData->top[start] : DiagData->bot[start]; // maximum of the two indices: thus j >  i
+        jloc =  DiagData->top[start] > DiagData->bot[start] ? 0 : 1;
+        //fprintf(stderr,"(%i) my (%i,%i), loc(%i,%i)\n",P->Par.me, i,j, iloc, jloc);
+        
+        // calculate rotation angle, i.e. c and s
+        //fprintf(stderr,"(%i),(%i,%i) calculate rotation angle\n",P->Par.me,i,j);
+        gsl_matrix_set_zero(G);        
+        for (k=0;k<DiagData->NumMatrices;k++) { // go through all operators ...
+          // Calculate vector h(a) = [a_ii - a_jj, a_ij + a_ji, i(a_ji - a_ij)]         
+          //fprintf(stderr,"(%i) k%i [a_ii - a_jj] = %e - %e = %e\n",P->Par.me, k,Aloc[k][2*round+iloc][i], Aloc[k][2*round+jloc][j],Aloc[k][2*round+iloc][i] - Aloc[k][2*round+jloc][j]);          
+          //fprintf(stderr,"(%i) k%i [a_ij + a_ji] = %e + %e = %e\n",P->Par.me, k,Aloc[k][2*round+jloc][i], Aloc[k][2*round+iloc][j],Aloc[k][2*round+jloc][i] + Aloc[k][2*round+iloc][j]);          
+          gsl_vector_set(h, 0, Aloc[k][2*round+iloc][i] - Aloc[k][2*round+jloc][j]);
+          gsl_vector_set(h, 1, Aloc[k][2*round+jloc][i] + Aloc[k][2*round+iloc][j]);
+          
+          // Calculate G = Re[ \sum_k h^H (A^{(k)}) h(A^{(k)}) ]
+          for (l=0;l<2;l++)
+            for (m=0;m<2;m++)
+                gsl_matrix_set(G,l,m, gsl_vector_get(h,l) * gsl_vector_get(h,m) + gsl_matrix_get(G,l,m));
         }
-      }  
-      m = -1; // to access U matrix element (0..Num-1)
-      for (j=0; j < Psi->MaxPsiOfType+P->Par.Max_me_comm_ST_PsiT; j++) {  // go through all wave functions
-        OnePsiB = &Psi->AllPsiStatus[j];    // grab OnePsiB
-        if (OnePsiB->PsiType == type) {   // drop all but occupied ones
-          m++;  // increase m if it is non-extra wave function
-          if (OnePsiB->my_color_comm_ST_Psi == P->Par.my_color_comm_ST_Psi) // local?
-             LOnePsiB = &Psi->LocalPsiStatus[OnePsiB->MyLocalNo];
-          else 
-             LOnePsiB = NULL;
-          if (LOnePsiB == NULL) {   // if it's not local ... receive it from respective process into TempPsi
-            RecvSource = OnePsiB->my_color_comm_ST_Psi;
-            MPI_Recv( LevS->LPsi->TempPsi, LevS->MaxG*ElementSize, MPI_DOUBLE, RecvSource, WannierTag2, P->Par.comm_ST_PsiT, &status );
-            LPsiDatB=LevS->LPsi->TempPsi;
-          } else {                  // .. otherwise send it to all other processes (Max_me... - 1)
-            for (p=0;p<P->Par.Max_me_comm_ST_PsiT;p++)
-              if (p != OnePsiB->my_color_comm_ST_Psi) 
-                MPI_Send( LevS->LPsi->LocalPsi[OnePsiB->MyLocalNo], LevS->MaxG*ElementSize, MPI_DOUBLE, p, WannierTag2, P->Par.comm_ST_PsiT);
-            LPsiDatB=LevS->LPsi->LocalPsi[OnePsiB->MyLocalNo];
-          } // LPsiDatB is now set to the coefficients of OnePsi either stored or MPI_Received
-
-          for (u=0;u<max_operators;u++) {
-            a_ij = 0;
-            b_ij = 0;
-            if (LPsiDatA != NULL) { // calculate, reduce and send to all ...
-              //fprintf(stderr,"(%i),(%i,%i): A[%i]: multiplying with \\phi_B\n",P->Par.me, l,m,u);
-              g=0;
-              if (LevS->GArray[0].GSq == 0.0) {
-                Index = LevS->GArray[g].Index;
-                a_ij = (LPsiDatB[0].re*HGcRC[u][Index].re + LPsiDatB[0].im*HGcRC[u][Index].im);
-                b_ij = (LPsiDatB[0].re*HGcR2C[u][Index].re + LPsiDatB[0].im*HGcR2C[u][Index].im);
-                g++;
-              }
-              for (; g < LevS->MaxG; g++) {
-                Index = LevS->GArray[g].Index;
-                a_ij += 2*(LPsiDatB[g].re*HGcRC[u][Index].re + LPsiDatB[g].im*HGcRC[u][Index].im);
-                b_ij += 2*(LPsiDatB[g].re*HGcR2C[u][Index].re + LPsiDatB[g].im*HGcR2C[u][Index].im);
-              } // due to the symmetry the resulting matrix element is real and symmetric in (i,j) ! (complex multiplication simplifies ...)
-              // sum up elements from all coefficients sharing processes
-              MPI_Allreduce ( &a_ij, &A_ij, 1, MPI_DOUBLE, MPI_SUM, P->Par.comm_ST_Psi);
-              MPI_Allreduce ( &b_ij, &B_ij, 1, MPI_DOUBLE, MPI_SUM, P->Par.comm_ST_Psi);
-              a_ij = A_ij;
-              b_ij = B_ij;
-              // send element to all Psi-sharing who don't have l local (MPI_Send is a lot slower than AllReduce!)
-              MPI_Allreduce ( &a_ij, &A_ij, 1, MPI_DOUBLE, MPI_SUM, P->Par.comm_ST_PsiT);
-              MPI_Allreduce ( &b_ij, &B_ij, 1, MPI_DOUBLE, MPI_SUM, P->Par.comm_ST_PsiT);
-            } else { // receive ...
-              MPI_Allreduce ( &a_ij, &A_ij, 1, MPI_DOUBLE, MPI_SUM, P->Par.comm_ST_PsiT);
-              MPI_Allreduce ( &b_ij, &B_ij, 1, MPI_DOUBLE, MPI_SUM, P->Par.comm_ST_PsiT);              
-            }
-            // ... and store
-            //fprintf(stderr,"(%i),(%i,%i): A[%i]: setting component (local: %lg, total: %lg)\n",P->Par.me, l,m,u,a_ij,A_ij);
-            //fprintf(stderr,"(%i),(%i,%i): B: adding upon component (local: %lg, total: %lg)\n",P->Par.me, l,m,b_ij,B_ij);
-            gsl_matrix_set(A[u], l, m, A_ij);
-            gsl_matrix_set(A[max_operators], l, m, B_ij + gsl_matrix_get(A[max_operators],l,m));
+        //fprintf(stderr,"(%i),(%i,%i) STEP 3b\n",P->Par.me,i,j);
+        // STEP 3b: retrieve eigenvector which belongs to greatest eigenvalue of G
+        EigensolverFor22Matrix(P,G,eval,evec);
+        //gsl_eigen_symmv(G, eval, evec, w);  // calculates eigenvalues and eigenvectors of G    
+
+        CalculateRotationAnglesFromEigenvalues(evec, eval, &c[round], &s[round]);
+        //fprintf(stderr,"(%i),(%i,%i) COS %e\t SIN %e\n",P->Par.me,i,j,c[round],s[round]);
+
+        //fprintf(stderr,"(%i),(%i,%i) STEP 3e\n",P->Par.me,i,j);
+        // V_loc = V_loc * V_small
+        //debug(P,"apply rotation to local U");
+        for (l=0;l<DiagData->AllocNum;l++) {
+          a_i = Uloc[2*round+iloc][l];
+          a_j = Uloc[2*round+jloc][l];
+          Uloc[2*round+iloc][l] =  c[round] * a_i + s[round] * a_j;
+          Uloc[2*round+jloc][l] = -s[round] * a_i + c[round] * a_j;
+        }
+      }  // end of round        
+      // circulate the rotation angles
+      //debug(P,"circulate the rotation angles");
+      MPI_Allgather(c, max_rounds, MPI_DOUBLE, c_all, max_rounds, MPI_DOUBLE, *(DiagData->comm));   // MPI_Allgather is waaaaay faster than ring circulation
+      MPI_Allgather(s, max_rounds, MPI_DOUBLE, s_all, max_rounds, MPI_DOUBLE, *(DiagData->comm));
+      //m = start;
+      for (l=0;l<DiagData->AllocNum/2;l++) { // for each process
+        // we have V_small from process k
+        //debug(P,"Apply V_small from other process");
+        i = DiagData->top[l] < DiagData->bot[l] ? DiagData->top[l] : DiagData->bot[l]; // minimum of the two indices
+        j = DiagData->top[l] > DiagData->bot[l] ? DiagData->top[l] : DiagData->bot[l]; // maximum of the two indices: thus j >  i
+        iloc = DiagData->top[l] < DiagData->bot[l] ? 0 : 1; 
+        jloc = DiagData->top[l] > DiagData->bot[l] ? 0 : 1;
+        for (m=0;m<max_rounds;m++) {
+          //fprintf(stderr,"(%i) %i processes' (%i,%i)\n",P->Par.me, m,i,j);
+          // apply row rotation to each A[k]
+          for (k=0;k<DiagData->NumMatrices+DiagData->extra;k++) {// one extra for B matrix !
+            //fprintf(stderr,"(%i) A:(k%i) a_i[%i] %e\ta_j[%i] %e\n",P->Par.me, k, i, Aloc[k][2*m+iloc][i],j,Aloc[k][2*m+iloc][j]);
+            //fprintf(stderr,"(%i) A:(k%i) a_i[%i] %e\ta_j[%i] %e\n",P->Par.me, k, i, Aloc[k][2*m+jloc][i],j,Aloc[k][2*m+jloc][j]);
+            a_i = Aloc[k][2*m+iloc][i];
+            a_j = Aloc[k][2*m+iloc][j];
+            Aloc[k][2*m+iloc][i] =  c_all[l] * a_i + s_all[l] * a_j;
+            Aloc[k][2*m+iloc][j] = -s_all[l] * a_i + c_all[l] * a_j;
+            a_i = Aloc[k][2*m+jloc][i];
+            a_j = Aloc[k][2*m+jloc][j];
+            Aloc[k][2*m+jloc][i] =  c_all[l] * a_i + s_all[l] * a_j;
+            Aloc[k][2*m+jloc][j] = -s_all[l] * a_i + c_all[l] * a_j;
+            //fprintf(stderr,"(%i) A^%i: a_i[%i] %e\ta_j[%i] %e\n",P->Par.me, k, i, Aloc[k][2*m+iloc][i],j,Aloc[k][2*m+iloc][j]);
+            //fprintf(stderr,"(%i) A^%i: a_i[%i] %e\ta_j[%i] %e\n",P->Par.me, k, i, Aloc[k][2*m+jloc][i],j,Aloc[k][2*m+jloc][j]);
           }
         }
       }
-    }
-  }
-  // reset extra entries
-  for (u=0;u<=max_operators;u++) {
-    for (i=Num;i<AllocNum;i++)
-      for (j=0;j<AllocNum;j++)
-        gsl_matrix_set(A[u], i,j, 0.);
-    for (i=Num;i<AllocNum;i++)
-      for (j=0;j<AllocNum;j++)
-        gsl_matrix_set(A[u], j,i, 0.);
-  }
-  // free lookups
-  for (i=0;i<NDIM;i++) {
-    Free(cos_lookup[i], "bla");
-    Free(sin_lookup[i], "bla");
-  }
-  Free(cos_lookup, "bla");
-  Free(sin_lookup, "bla");
-  
-  if(P->Call.out[ReadOut]) fprintf(stderr,"(%i) STEP 1\n",P->Par.me);
-  // STEP 1: Initialize U = 1
-  gsl_matrix *U = gsl_matrix_alloc (AllocNum,AllocNum);
-  gsl_matrix_set_identity(U);
-
-  // init merry-go-round array
-  top = (int *) Malloc(sizeof(int)*AllocNum/2, "ComputeMLWF: top");
-  bot = (int *) Malloc(sizeof(int)*AllocNum/2, "ComputeMLWF: bot");
-  //debug(P,"init merry-go-round array");
-  for (i=0;i<AllocNum/2;i++) {
-    top[i] = 2*i;
-    bot[i] = 2*i+1;      
-  }
-
-/*// print A matrices for debug
-  if (P->Par.me == 0) 
-    for (u=0;u<max_operators+1;u++) {
-     fprintf(stderr, "A[%i] = \n",u);
-      for (i=0;i<Num;i++) {
-        for (j=0;j<Num;j++)
-          fprintf(stderr, "%e\t",gsl_matrix_get(A[u],i,j));
-        fprintf(stderr, "\n");
-      }
-    }  
-*/
-  if (Num != 1) {
-    // one- or multi-process case?
-    if (((AllocNum % 2) == 0) && (ProcNum != 1) && ((AllocNum / 2) % ProcNum == 0)) {
-      max_rounds = (AllocNum / 2)/ProcNum;  // each process must perform multiple rotations per step of a set
-      //fprintf(stderr,"(%i) start %i\tstep %i\tmax.rounds %i\n",P->Par.me, ProcRank, ProcNum, max_rounds);
-      // allocate column vectors for interchange of columns
-      //debug(P,"allocate column vectors for interchange of columns");
-      c = (double *) Malloc(sizeof(double)*max_rounds, "ComputeMLWF: c");
-      s = (double *) Malloc(sizeof(double)*max_rounds, "ComputeMLWF: s");
-      c_all = (double *) Malloc(sizeof(double)*AllocNum/2, "ComputeMLWF: c_all");
-      s_all = (double *) Malloc(sizeof(double)*AllocNum/2, "ComputeMLWF: s_all");
-      rcounts = (int *) Malloc(sizeof(int)*ProcNum, "ComputeMLWF: rcounts");
-      rdispls = (int *) Malloc(sizeof(int)*ProcNum, "ComputeMLWF: rdispls");
-/*    // print starting values of index generation tables top and bot
-      fprintf(stderr,"top\t");
-      for (k=0;k<AllocNum/2;k++)
-        fprintf(stderr,"%i\t", top[k]);
-      fprintf(stderr,"\n");
-      fprintf(stderr,"bot\t");
-      for (k=0;k<AllocNum/2;k++)
-        fprintf(stderr,"%i\t", bot[k]);
-      fprintf(stderr,"\n");*/
-      // establish communication partners
-      //debug(P,"establish communication partners");
-      if (ProcRank == 0) {
-        tagS0 = WannierALTag;   // left p0 always remains left p0
-      } else {
-        tagS0 = ProcRank == ProcNum - 1 ? WannierARTag : WannierALTag; // left p_last becomes right p_last          
-      }
-      tagS1 = ProcRank == 0 ? WannierALTag : WannierARTag; // right p0 always goes into left p1
-      tagR0 = WannierALTag; // 
-      tagR1 = WannierARTag; // first process
-      if (ProcRank == 0) {
-        left = ProcNum-1;
-        right = 1;
-        Lsend = 0;
-        Rsend = 1;
-        Lrecv = 0;
-        Rrecv = 1;        
-      } else if (ProcRank == ProcNum - 1) {
-        left = ProcRank - 1;
-        right = 0;
-        Lsend = ProcRank;
-        Rsend = ProcRank - 1;
-        Lrecv = ProcRank - 1;
-        Rrecv = ProcRank;        
-      } else {
-        left = ProcRank - 1;
-        right = ProcRank + 1;
-        Lsend = ProcRank+1;
-        Rsend = ProcRank - 1;
-        Lrecv = ProcRank - 1;
-        Rrecv = ProcRank+1;
-      }
-      //fprintf(stderr,"(%i) left %i\t right %i --- Lsend %i\tRsend%i\tLrecv %i\tRrecv%i\n",P->Par.me, left, right, Lsend, Rsend, Lrecv, Rrecv);
-      // allocate eigenvector stuff
-      //debug(P,"allocate eigenvector stuff");
-      G = gsl_matrix_calloc (2,2);
-      h = gsl_vector_alloc (2);
-      eval = gsl_vector_alloc (2);
-      evec = gsl_matrix_alloc (2,2);
-      w = gsl_eigen_symmv_alloc(2);
-      // initialise A_loc
-      //debug(P,"initialise A_loc");
-      for (k=0;k<max_operators+1;k++) {
-        //Aloc[k] = (double *) Malloc(sizeof(double)*AllocNum*2, "ComputeMLWF: Aloc[k]");
-        Around[k] = (double *) Malloc(sizeof(double)*AllocNum*2*max_rounds, "ComputeMLWF: Around[k]");
-        Atotal[k] = (double *) Malloc(sizeof(double)*AllocNum*AllocNum, "ComputeMLWF: Atotal[k]");
-        Aloc[k] = (double **) Malloc(sizeof(double *)*2*max_rounds, "ComputeMLWF: Aloc[k]");
-        //Around[k] = &Atotal[k][ProcRank*AllocNum*2*max_rounds];
-        
-        for (round=0;round<max_rounds;round++) {
-          Aloc[k][2*round] = &Around[k][AllocNum*(2*round)];
-          Aloc[k][2*round+1] = &Around[k][AllocNum*(2*round+1)];
-          for (l=0;l<AllocNum;l++) {
-            Aloc[k][2*round][l] = gsl_matrix_get(A[k],l,2*(ProcRank*max_rounds+round));
-            Aloc[k][2*round+1][l] = gsl_matrix_get(A[k],l,2*(ProcRank*max_rounds+round)+1);
-            //fprintf(stderr,"(%i) (%i, 0/1) A_loc1 %e\tA_loc2 %e\n",P->Par.me, l, Aloc[k][l],Aloc[k][l+AllocNum]);
+      // apply rotation to local operator matrices
+      // A_loc = A_loc * V_small 
+      //debug(P,"apply rotation to local operator matrices A[k]");
+      for (m=0;m<max_rounds;m++) {
+        start = DiagData->ProcRank * max_rounds + m;
+        iloc = DiagData->top[start] < DiagData->bot[start] ? 0 : 1; 
+        jloc = DiagData->top[start] > DiagData->bot[start] ? 0 : 1;
+        for (k=0;k<DiagData->NumMatrices+DiagData->extra;k++) {// extra for B matrix !
+          for (l=0;l<DiagData->AllocNum;l++) {
+            // Columns, i and j belong to this process only!
+            a_i = Aloc[k][2*m+iloc][l];
+            a_j = Aloc[k][2*m+jloc][l];
+            Aloc[k][2*m+iloc][l] =  c[m] * a_i + s[m] * a_j;
+            Aloc[k][2*m+jloc][l] = -s[m] * a_i + c[m] * a_j;
+            //fprintf(stderr,"(%i) A:(k%i) a_i[%i] %e\ta_j[%i] %e\n",P->Par.me, k, l, Aloc[k][2*m+iloc][l],l,Aloc[k][2*m+jloc][l]);
           }
         }
       }
-      // initialise U_loc
-      //debug(P,"initialise U_loc");
-      //Uloc = (double *) Malloc(sizeof(double)*AllocNum*2, "ComputeMLWF: Uloc");
-      Uround = (double *) Malloc(sizeof(double)*AllocNum*2*max_rounds, "ComputeMLWF: Uround");
-      Utotal = (double *) Malloc(sizeof(double)*AllocNum*AllocNum, "ComputeMLWF: Utotal");
-      Uloc = (double **) Malloc(sizeof(double *)*2*max_rounds, "ComputeMLWF: Uloc");
-      //Uround = &Utotal[ProcRank*AllocNum*2*max_rounds];
-      for (round=0;round<max_rounds;round++) {
-        Uloc[2*round] = &Uround[AllocNum*(2*round)];
-        Uloc[2*round+1] = &Uround[AllocNum*(2*round+1)];
-        for (l=0;l<AllocNum;l++) {
-          Uloc[2*round][l] = gsl_matrix_get(U,l,2*(ProcRank*max_rounds+round));
-          Uloc[2*round+1][l] = gsl_matrix_get(U,l,2*(ProcRank*max_rounds+round)+1);
-          //fprintf(stderr,"(%i) (%i, 0/1) U_loc1 %e\tU_loc2 %e\n",P->Par.me, l, Uloc[l+AllocNum*0],Uloc[l+AllocNum*1]);
+      // Shuffling of these round's columns to prepare next rotation set
+      for (k=0;k<DiagData->NumMatrices+DiagData->extra;k++) {// one extra for B matrix ! 
+        // extract columns from A
+        //debug(P,"extract columns from A");
+        MerryGoRoundColumns(*(DiagData->comm), Aloc[k], DiagData->AllocNum, max_rounds, k, tagS0, tagS1, tagR0, tagR1);
+                  
+      }       
+      // and also for V ...
+      //debug(P,"extract columns from U");
+      MerryGoRoundColumns(*(DiagData->comm), Uloc, DiagData->AllocNum, max_rounds, 0, tagS0, tagS1, tagR0, tagR1);
+
+
+      // and merry-go-round for the indices too            
+      //debug(P,"and merry-go-round for the indices too");
+      MerryGoRoundIndices(DiagData->top, DiagData->bot, DiagData->AllocNum/2);
+    }
+
+    //fprintf(stderr,"(%i) STEP 4\n",P->Par.me);
+    // STEP 4: calculate new variance: \sum_{ik} (A^{(k)}_ii)^2
+    old_spread = Spread;
+    spread = 0.;
+    for(k=0;k<DiagData->NumMatrices;k++) {   // go through all self-adjoint operators
+      for (i=0; i < 2*max_rounds; i++) {  // go through all wave functions
+          spread += Aloc[k][i][i+DiagData->ProcRank*2*max_rounds]*Aloc[k][i][i+DiagData->ProcRank*2*max_rounds];
+          //spread += gsl_matrix_get(A[k],i,i)*gsl_matrix_get(A[k],i,i);
+      }
+    }
+    MPI_Allreduce(&spread, &Spread, 1, MPI_DOUBLE, MPI_SUM, *(DiagData->comm));
+    //Spread = spread;
+    if (P->Par.me == 0) { 
+      //if(P->Call.out[ReadOut]) 
+      //  fprintf(stderr,"(%i) STEP 5: %2.9e - %2.9e <= %lg ?\n",P->Par.me,old_spread,Spread,R->EpsWannier);
+      //else 
+        //fprintf(stderr,"%2.9e\n",Spread);
+    }
+    // STEP 5: check change of variance
+  } while (fabs(old_spread-Spread) >= R->EpsWannier);
+  // end of iterative diagonalization loop: We have found our final orthogonal U!
+
+  // gather local parts of U into complete matrix 
+  for (l=0;l<DiagData->ProcNum;l++)
+    rcounts[l] = DiagData->AllocNum;
+  debug(P,"allgather U");
+  for (round=0;round<2*max_rounds;round++) {
+    for (l=0;l<DiagData->ProcNum;l++)
+      rdispls[l] = (l*2*max_rounds + round)*DiagData->AllocNum;
+    MPI_Allgatherv(Uloc[round], DiagData->AllocNum, MPI_DOUBLE, Utotal, rcounts, rdispls, MPI_DOUBLE, *(DiagData->comm));
+  }
+  for (k=0;k<DiagData->AllocNum;k++) {    
+    for(l=0;l<DiagData->AllocNum;l++) {
+      gsl_matrix_set(DiagData->U,k,l, Utotal[l+k*DiagData->AllocNum]);
+    }
+  }
+
+  // after one set, gather A[k] from all and calculate spread
+  for (l=0;l<DiagData->ProcNum;l++)
+    rcounts[l] = DiagData->AllocNum;
+  debug(P,"gather A[k] for spread");
+  for (u=0;u<DiagData->NumMatrices+DiagData->extra;u++) {// extra for B matrix !
+    debug(P,"A[k] all gather");
+    for (round=0;round<2*max_rounds;round++) {
+      for (l=0;l<DiagData->ProcNum;l++)
+        rdispls[l] = (l*2*max_rounds + round)*DiagData->AllocNum;
+      MPI_Allgatherv(Aloc[u][round], DiagData->AllocNum, MPI_DOUBLE, Atotal[u], rcounts, rdispls, MPI_DOUBLE, *(DiagData->comm));
+    }
+    for (k=0;k<DiagData->AllocNum;k++) {    
+      for(l=0;l<DiagData->AllocNum;l++) {
+        gsl_matrix_set(DiagData->A[u],k,l, Atotal[u][l+k*DiagData->AllocNum]);
+      }
+    }
+  }
+   
+  // free eigenvector stuff     
+  gsl_vector_free(h);
+  gsl_matrix_free(G);
+  //gsl_eigen_symmv_free(w);  
+  gsl_vector_free(eval);
+  gsl_matrix_free(evec);
+ 
+  // Free column vectors
+  for (k=0;k<DiagData->NumMatrices+DiagData->extra;k++) {
+    Free(Atotal[k], "ParallelDiagonalization: Atotal[k]");
+    Free(Around[k], "ParallelDiagonalization: Around[k]");
+  }
+  Free(Uround, "ParallelDiagonalization: Uround");
+  Free(Utotal, "ParallelDiagonalization: Utotal");
+  Free(c_all, "ParallelDiagonalization: c_all");
+  Free(s_all, "ParallelDiagonalization: s_all");
+  Free(c, "ParallelDiagonalization: c");
+  Free(s, "ParallelDiagonalization: s");
+  Free(rcounts, "ParallelDiagonalization: rcounts");
+  Free(rdispls, "ParallelDiagonalization: rdispls");
+}
+/*
+ * \param **A matrices (pointer array with \a NumMatrices entries) to be diagonalized
+ * \param *U transformation matrix set to unity matrix
+ * \param NumMatrices number of matrices to be diagonalized
+ * \param extra number of additional matrices the rotation is applied to however which actively diagonalized (follow in \a **A)
+ * \param AllocNum number of rows/columns in matrices
+ * \param Num number of wave functions
+ * \param *top array with top row indices (merry-go-round)
+ * \param *bot array with bottom row indices (merry-go-round) 
+ */
+
+/** Simultaneous Diagonalization of variances matrices with one cpu.
+ * \param *P Problem at hand
+ * \param *DiagData pointer to structure DiagonalizationData containing necessary information for diagonalization
+ * \note this is faster given one cpu only than ParallelDiagonalization()
+ */
+void SerialDiagonalization(struct Problem *P, struct DiagonalizationData *DiagData)
+{
+  struct RunStruct *R = &P->R;
+  gsl_matrix *G;
+  gsl_vector *h;
+  gsl_vector *eval;
+  gsl_matrix *evec;
+  //gsl_eigen_symmv_workspace *w;
+  double *c,*s,a_i,a_j;
+  int it_steps, set, ProcRank;
+  int i,j,k,l,m;
+  double spread = 0., old_spread = 0.;\
+
+  // allocate eigenvector stuff
+  debug(P,"allocate eigenvector stuff");
+  G = gsl_matrix_calloc (2,2);
+  h = gsl_vector_alloc (2);
+  eval = gsl_vector_alloc (2);
+  evec = gsl_matrix_alloc (2,2);
+  //w = gsl_eigen_symmv_alloc(2);
+
+  c = (double *) Malloc(sizeof(double), "ComputeMLWF: c");
+  s = (double *) Malloc(sizeof(double), "ComputeMLWF: s");
+  debug(P,"now comes the iteration loop");
+  it_steps=0;
+  do {
+    it_steps++;
+    //if(P->Call.out[ReadOut]) fprintf(stderr,"(%i) STEP 3: Iteratively maximize negative spread part\n",P->Par.me);
+    //if(P->Call.out[ReadOut]) fprintf(stderr,"(%i) Beginning iteration %i ... ",P->Par.me,it_steps);
+    for (set=0; set < DiagData->AllocNum-1; set++) { // one column less due to column 0 stating at its place all the time
+      //fprintf(stderr,"(%i) Beginning rotation set %i ...\n",P->Par.me,set);
+      // STEP 3: for all index pairs 0<= i<j <AllocNum
+      for (ProcRank=0;ProcRank<DiagData->AllocNum/2;ProcRank++) {
+        // get indices
+        i = DiagData->top[ProcRank] < DiagData->bot[ProcRank] ? DiagData->top[ProcRank] : DiagData->bot[ProcRank]; // minimum of the two indices
+        j = DiagData->top[ProcRank] > DiagData->bot[ProcRank] ? DiagData->top[ProcRank] : DiagData->bot[ProcRank]; // maximum of the two indices: thus j >  i 
+        //fprintf(stderr,"(%i),(%i,%i) STEP 3a\n",P->Par.me,i,j);
+        // STEP 3a: Calculate G
+        gsl_matrix_set_zero(G);
+        
+        for (k=0;k<DiagData->NumMatrices;k++) { // go through all operators ...
+          // Calculate vector h(a) = [a_ii - a_jj, a_ij + a_ji, i(a_ji - a_ij)]
+          //fprintf(stderr,"(%i) k%i [a_ii - a_jj] = %e - %e = %e\n",P->Par.me, k,gsl_matrix_get(DiagData->A[k],i,i), gsl_matrix_get(DiagData->A[k],j,j),gsl_matrix_get(DiagData->A[k],i,i) - gsl_matrix_get(DiagData->A[k],j,j));          
+          //fprintf(stderr,"(%i) k%i [a_ij + a_ji] = %e + %e = %e\n",P->Par.me, k,gsl_matrix_get(DiagData->A[k],i,j), gsl_matrix_get(DiagData->A[k],j,i),gsl_matrix_get(DiagData->A[k],i,j) + gsl_matrix_get(DiagData->A[k],j,i));          
+          gsl_vector_set(h, 0, gsl_matrix_get(DiagData->A[k],i,i) - gsl_matrix_get(DiagData->A[k],j,j));
+          gsl_vector_set(h, 1, gsl_matrix_get(DiagData->A[k],i,j) + gsl_matrix_get(DiagData->A[k],j,i));
+          //gsl_vector_complex_set(h, 2, gsl_complex_mul_imag(gsl_complex_add(gsl_matrix_complex_get(A[k],j,i), gsl_matrix_complex_get(A[k],i,j)),1));
+          
+          // Calculate G = Re[ \sum_k h^H (A^{(k)}) h(A^{(k)}) ]
+          for (l=0;l<2;l++)
+            for (m=0;m<2;m++)
+                gsl_matrix_set(G,l,m, gsl_vector_get(h,l) * gsl_vector_get(h,m) + gsl_matrix_get(G,l,m));
+                
+          //PrintGSLMatrix(P,G,2, "G");
         }
-      }
-      // now comes the iteration loop
-      //debug(P,"now comes the iteration loop");
-      it_steps = 0;
-      do {
-        it_steps++;
-        fprintf(stderr,"(%i) Beginning parallel iteration %i ... ",P->Par.me,it_steps);
-        for (set=0; set < AllocNum-1; set++) { // one column less due to column 0 stating at its place all the time
-          //fprintf(stderr,"(%i) Beginning rotation set %i ...\n",P->Par.me,set);
-          for (round = 0; round < max_rounds;round++) {
-            start = ProcRank * max_rounds + round;
-            // get indices
-            i = top[start] < bot[start] ? top[start] : bot[start]; // minimum of the two indices
-            iloc = top[start] < bot[start] ? 0 : 1; 
-            j = top[start] > bot[start] ? top[start] : bot[start]; // maximum of the two indices: thus j >  i
-            jloc =  top[start] > bot[start] ? 0 : 1;
-            //fprintf(stderr,"(%i) my (%i,%i), loc(%i,%i)\n",P->Par.me, i,j, iloc, jloc);
-            
-            // calculate rotation angle, i.e. c and s
-            //fprintf(stderr,"(%i),(%i,%i) calculate rotation angle\n",P->Par.me,i,j);
-            gsl_matrix_set_zero(G);        
-            for (k=0;k<max_operators;k++) { // go through all operators ...
-              // Calculate vector h(a) = [a_ii - a_jj, a_ij + a_ji, i(a_ji - a_ij)]         
-              //fprintf(stderr,"(%i) k%i [a_ii - a_jj] = %e - %e = %e\n",P->Par.me, k,Aloc[k][2*round+iloc][i], Aloc[k][2*round+jloc][j],Aloc[k][2*round+iloc][i] - Aloc[k][2*round+jloc][j]);          
-              //fprintf(stderr,"(%i) k%i [a_ij + a_ji] = %e - %e = %e\n",P->Par.me, k,Aloc[k][2*round+jloc][i], Aloc[k][2*round+iloc][j],Aloc[k][2*round+jloc][i] + Aloc[k][2*round+iloc][j]);          
-              gsl_vector_set(h, 0, Aloc[k][2*round+iloc][i] - Aloc[k][2*round+jloc][j]);
-              gsl_vector_set(h, 1, Aloc[k][2*round+jloc][i] + Aloc[k][2*round+iloc][j]);
-              
-              // Calculate G = Re[ \sum_k h^H (A^{(k)}) h(A^{(k)}) ]
-              for (l=0;l<2;l++)
-                for (m=0;m<2;m++)
-                    gsl_matrix_set(G,l,m, gsl_vector_get(h,l) * gsl_vector_get(h,m) + gsl_matrix_get(G,l,m));
-            }
-            //fprintf(stderr,"(%i),(%i,%i) STEP 3b\n",P->Par.me,i,j);
-            // STEP 3b: retrieve eigenvector which belongs to greatest eigenvalue of G
-            gsl_eigen_symmv(G, eval, evec, w);  // calculates eigenvalues and eigenvectors of G    
-            index = gsl_vector_max_index (eval);  // get biggest eigenvalue
-            x = gsl_matrix_get(evec, 0, index);
-            y = gsl_matrix_get(evec, 1, index) * x/fabs(x);
-            x = fabs(x);  // ensure x>=0 so that rotation angles remain smaller Pi/4     
-            //fprintf(stderr,"(%i),(%i,%i) STEP 3c\n",P->Par.me,i,j);
-            // STEP 3c: calculate R = [[c,s^\ast],[-s,c^\ast]]
-            r = sqrt(x*x + y*y);
-            c[round] = sqrt((x + r) / (2*r));
-            s[round] = y / sqrt(2*r*(x+r));
-            // [[c,s],[-s,c]]= V_small
-            //fprintf(stderr,"(%i),(%i,%i) COS %e\t SIN %e\n",P->Par.me,i,j,c[round],s[round]);
-    
-            //fprintf(stderr,"(%i),(%i,%i) STEP 3e\n",P->Par.me,i,j);
-            // V_loc = V_loc * V_small
-            //debug(P,"apply rotation to local U");
-            for (l=0;l<AllocNum;l++) {
-              a_i = Uloc[2*round+iloc][l];
-              a_j = Uloc[2*round+jloc][l];
-              Uloc[2*round+iloc][l] =  c[round] * a_i + s[round] * a_j;
-              Uloc[2*round+jloc][l] = -s[round] * a_i + c[round] * a_j;
-            }
-          }  // end of round        
-          // circulate the rotation angles
-          //debug(P,"circulate the rotation angles");
-          MPI_Allgather(c, max_rounds, MPI_DOUBLE, c_all, max_rounds, MPI_DOUBLE, *comm);   // MPI_Allgather is waaaaay faster than ring circulation
-          MPI_Allgather(s, max_rounds, MPI_DOUBLE, s_all, max_rounds, MPI_DOUBLE, *comm);
-          //m = start;
-          for (l=0;l<AllocNum/2;l++) { // for each process
-            // we have V_small from process k
-            //debug(P,"Apply V_small from other process");
-            i = top[l] < bot[l] ? top[l] : bot[l]; // minimum of the two indices
-            j = top[l] > bot[l] ? top[l] : bot[l]; // maximum of the two indices: thus j >  i
-            iloc = top[l] < bot[l] ? 0 : 1; 
-            jloc =  top[l] > bot[l] ? 0 : 1;
-            for (m=0;m<max_rounds;m++) {
-              //fprintf(stderr,"(%i) %i processes' (%i,%i)\n",P->Par.me, m,i,j);
-              // apply row rotation to each A[k]
-              for (k=0;k<max_operators+1;k++) {// one extra for B matrix !
-                //fprintf(stderr,"(%i) A:(k%i) a_i[%i] %e\ta_j[%i] %e\n",P->Par.me, k, i, Aloc[k][2*m+iloc][i],j,Aloc[k][2*m+iloc][j]);
-                //fprintf(stderr,"(%i) A:(k%i) a_i[%i] %e\ta_j[%i] %e\n",P->Par.me, k, i, Aloc[k][2*m+jloc][i],j,Aloc[k][2*m+jloc][j]);
-                a_i = Aloc[k][2*m+iloc][i];
-                a_j = Aloc[k][2*m+iloc][j];
-                Aloc[k][2*m+iloc][i] =  c_all[l] * a_i + s_all[l] * a_j;
-                Aloc[k][2*m+iloc][j] = -s_all[l] * a_i + c_all[l] * a_j;
-                a_i = Aloc[k][2*m+jloc][i];
-                a_j = Aloc[k][2*m+jloc][j];
-                Aloc[k][2*m+jloc][i] =  c_all[l] * a_i + s_all[l] * a_j;
-                Aloc[k][2*m+jloc][j] = -s_all[l] * a_i + c_all[l] * a_j;
-                //fprintf(stderr,"(%i) A^%i: a_i[%i] %e\ta_j[%i] %e\n",P->Par.me, k, i, Aloc[k][2*m+iloc][i],j,Aloc[k][2*m+iloc][j]);
-                //fprintf(stderr,"(%i) A^%i: a_i[%i] %e\ta_j[%i] %e\n",P->Par.me, k, i, Aloc[k][2*m+jloc][i],j,Aloc[k][2*m+jloc][j]);
-              }
-            }
+      
+        //fprintf(stderr,"(%i),(%i,%i) STEP 3b\n",P->Par.me,i,j);
+        // STEP 3b: retrieve eigenvector which belongs to greatest eigenvalue of G
+        EigensolverFor22Matrix(P,G,eval,evec);
+        //gsl_eigen_symmv(G, eval, evec, w);  // calculates eigenvalues and eigenvectors of G
+
+        //PrintGSLMatrix(P, evec, 2, "Eigenvectors");
+        CalculateRotationAnglesFromEigenvalues(evec, eval, c, s);
+        //fprintf(stderr,"(%i),(%i,%i) COS %e\t SIN %e\n",P->Par.me,i,j,c[0],s[0]);
+     
+        //fprintf(stderr,"(%i),(%i,%i) STEP 3d\n",P->Par.me,i,j);
+        // STEP 3d: apply rotation R to rows and columns of A^{(k)}
+        for (k=0;k<DiagData->NumMatrices+DiagData->extra;k++) {// one extra for B matrix !
+          //PrintGSLMatrix(P,A[k],AllocNum, "A (before rot)");
+          for (l=0;l<DiagData->AllocNum;l++) {
+            // Rows
+            a_i = gsl_matrix_get(DiagData->A[k],i,l);
+            a_j = gsl_matrix_get(DiagData->A[k],j,l);
+            gsl_matrix_set(DiagData->A[k], i, l,  c[0] * a_i + s[0] * a_j);
+            gsl_matrix_set(DiagData->A[k], j, l, -s[0] * a_i + c[0] * a_j);
           }
-          // apply rotation to local operator matrices
-          // A_loc = A_loc * V_small 
-          //debug(P,"apply rotation to local operator matrices A[k]");
-          for (m=0;m<max_rounds;m++) {
-            start = ProcRank * max_rounds + m;
-            iloc = top[start] < bot[start] ? 0 : 1; 
-            jloc =  top[start] > bot[start] ? 0 : 1;
-            for (k=0;k<max_operators+1;k++) {// one extra for B matrix !
-              for (l=0;l<AllocNum;l++) {
-                // Columns, i and j belong to this process only!
-                a_i = Aloc[k][2*m+iloc][l];
-                a_j = Aloc[k][2*m+jloc][l];
-                Aloc[k][2*m+iloc][l] =  c[m] * a_i + s[m] * a_j;
-                Aloc[k][2*m+jloc][l] = -s[m] * a_i + c[m] * a_j;
-                //fprintf(stderr,"(%i) A:(k%i) a_i[%i] %e\ta_j[%i] %e\n",P->Par.me, k, l, Aloc[k][2*m+iloc][l],l,Aloc[k][2*m+jloc][l]);
-              }
-            }
+          for (l=0;l<DiagData->AllocNum;l++) {
+            // Columns
+            a_i = gsl_matrix_get(DiagData->A[k],l,i);
+            a_j = gsl_matrix_get(DiagData->A[k],l,j);
+            gsl_matrix_set(DiagData->A[k], l, i,  c[0] * a_i + s[0] * a_j);
+            gsl_matrix_set(DiagData->A[k], l, j, -s[0] * a_i + c[0] * a_j);
           }
-          // Shuffling of these round's columns to prepare next rotation set
-          for (k=0;k<max_operators+1;k++) {// one extra for B matrix ! 
-            // extract columns from A
-            //debug(P,"extract columns from A");
-            shiftcolumns(*comm, Aloc[k], AllocNum, max_rounds, k, tagS0, tagS1, tagR0, tagR1);
-                      
-          }       
-          // and also for V ...
-          //debug(P,"extract columns from U");
-          shiftcolumns(*comm, Uloc, AllocNum, max_rounds, 0, tagS0, tagS1, tagR0, tagR1);
-
-    
-          // and merry-go-round for the indices too            
-          //debug(P,"and merry-go-round for the indices too");
-          music(top, bot, AllocNum/2);
+          //PrintGSLMatrix(P,A[k],AllocNum, "A (after rot)");
         }
-  
-        //fprintf(stderr,"(%i) STEP 4\n",P->Par.me);
-        // STEP 4: calculate new variance: \sum_{ik} (A^{(k)}_ii)^2
-        old_spread = Spread;
-        spread = 0.;
-        for(k=0;k<max_operators;k++) {   // go through all self-adjoint operators
-          for (i=0; i < 2*max_rounds; i++) {  // go through all wave functions
-              spread += Aloc[k][i][i+ProcRank*2*max_rounds]*Aloc[k][i][i+ProcRank*2*max_rounds];
-              //spread += gsl_matrix_get(A[k],i,i)*gsl_matrix_get(A[k],i,i);
-          }
+        //fprintf(stderr,"(%i),(%i,%i) STEP 3e\n",P->Par.me,i,j);
+        //PrintGSLMatrix(P,DiagData->U,DiagData->AllocNum, "U (before rot)");
+        // STEP 3e: apply U = R*U
+        for (l=0;l<DiagData->AllocNum;l++) {
+            a_i = gsl_matrix_get(DiagData->U,i,l);
+            a_j = gsl_matrix_get(DiagData->U,j,l);
+            gsl_matrix_set(DiagData->U, i, l,  c[0] * a_i + s[0] * a_j);
+            gsl_matrix_set(DiagData->U, j, l, -s[0] * a_i + c[0] * a_j);
         }
-        MPI_Allreduce(&spread, &Spread, 1, MPI_DOUBLE, MPI_SUM, *comm);
-        //Spread = spread;
-        if(P->Call.out[ReadOut]) fprintf(stderr,"(%i) STEP 5: %2.9e - %2.9e <= %lg ?\n",P->Par.me,old_spread,Spread,R->EpsWannier);
-        else fprintf(stderr,"%2.9e\n",Spread);
-        // STEP 5: check change of variance
-      } while (fabs(old_spread-Spread) >= R->EpsWannier);
-      // end of iterative diagonalization loop: We have found our final orthogonal U!
-
-      for (l=0;l<ProcNum;l++)
-        rcounts[l] = AllocNum;
-      //debug(P,"allgather U");
-      for (round=0;round<2*max_rounds;round++) {
-        for (l=0;l<ProcNum;l++)
-          rdispls[l] = (l*2*max_rounds + round)*AllocNum;
-        MPI_Allgatherv(Uloc[round], AllocNum, MPI_DOUBLE, Utotal, rcounts, rdispls, MPI_DOUBLE, *comm);
-      }
-      for (k=0;k<AllocNum;k++) {    
-        for(l=0;l<AllocNum;l++) {
-          gsl_matrix_set(U,k,l, Utotal[l+k*AllocNum]);
-        }
-      }
-
-
-      // after one set, gather A[k] from all and calculate spread
-      for (l=0;l<ProcNum;l++)
-        rcounts[l] = AllocNum;
-      //debug(P,"gather A[k] for spread");
-      for (u=0;u<max_operators+1;u++) {// one extra for B matrix !
-        //debug(P,"A[k] all gather");
-        for (round=0;round<2*max_rounds;round++) {
-          for (l=0;l<ProcNum;l++)
-            rdispls[l] = (l*2*max_rounds + round)*AllocNum;
-          MPI_Allgatherv(Aloc[u][round], AllocNum, MPI_DOUBLE, Atotal[u], rcounts, rdispls, MPI_DOUBLE, *comm);
-      	}
-        for (k=0;k<AllocNum;k++) {    
-          for(l=0;l<AllocNum;l++) {
-            gsl_matrix_set(A[u],k,l, Atotal[u][l+k*AllocNum]);
-          }
-        }
-      }
-     
-      // free eigenvector stuff     
-      gsl_vector_free(h);
-      gsl_matrix_free(G);
-      gsl_eigen_symmv_free(w);  
-      gsl_vector_free(eval);
-      gsl_matrix_free(evec);
-      // Free column vectors
-      for (k=0;k<max_operators+1;k++) {
-        Free(Atotal[k], "bla");
-        Free(Around[k], "bla");
-      }
-      Free(Uround, "bla");
-      Free(Utotal, "bla");
-      Free(c_all, "bla");
-      Free(s_all, "bla");
-      Free(c, "bla");
-      Free(s, "bla");
-      Free(rcounts, "bla");
-      Free(rdispls, "bla");
-      
-    } else {
-      
-      c = (double *) Malloc(sizeof(double), "ComputeMLWF: c");
-      s = (double *) Malloc(sizeof(double), "ComputeMLWF: s");
-      G = gsl_matrix_calloc (2,2);
-      h = gsl_vector_alloc (2);
-      eval = gsl_vector_alloc (2);
-      evec = gsl_matrix_alloc (2,2);
-      w = gsl_eigen_symmv_alloc(2);
-      //debug(P,"now comes the iteration loop");
-      it_steps=0;
-      do {
-        it_steps++;
-        //if(P->Call.out[ReadOut]) fprintf(stderr,"(%i) STEP 3: Iteratively maximize negative spread part\n",P->Par.me);
-        fprintf(stderr,"(%i) Beginning iteration %i ... ",P->Par.me,it_steps);
-        for (set=0; set < AllocNum-1; set++) { // one column less due to column 0 stating at its place all the time
-          //fprintf(stderr,"(%i) Beginning rotation set %i ...\n",P->Par.me,set);
-          // STEP 3: for all index pairs 0<= i<j <AllocNum
-          for (ProcRank=0;ProcRank<AllocNum/2;ProcRank++) {
-            // get indices
-            i = top[ProcRank] < bot[ProcRank] ? top[ProcRank] : bot[ProcRank]; // minimum of the two indices
-            j = top[ProcRank] > bot[ProcRank] ? top[ProcRank] : bot[ProcRank]; // maximum of the two indices: thus j >  i 
-            //fprintf(stderr,"(%i),(%i,%i) STEP 3a\n",P->Par.me,i,j);
-            // STEP 3a: Calculate G
-            gsl_matrix_set_zero(G);
-            
-            for (k=0;k<max_operators;k++) { // go through all operators ...
-              // Calculate vector h(a) = [a_ii - a_jj, a_ij + a_ji, i(a_ji - a_ij)]
-              //fprintf(stderr,"(%i) k%i [a_ii - a_ij] = %e - %e = %e\n",P->Par.me, k,gsl_matrix_get(A[k],i,i), gsl_matrix_get(A[k],j,j),gsl_matrix_get(A[k],i,i) - gsl_matrix_get(A[k],j,j));          
-              //fprintf(stderr,"(%i) k%i [a_ij + a_jij] = %e - %e = %e\n",P->Par.me, k,gsl_matrix_get(A[k],i,j), gsl_matrix_get(A[k],j,i),gsl_matrix_get(A[k],i,j) + gsl_matrix_get(A[k],j,i));          
-              gsl_vector_set(h, 0, gsl_matrix_get(A[k],i,i) - gsl_matrix_get(A[k],j,j));
-              gsl_vector_set(h, 1, gsl_matrix_get(A[k],i,j) + gsl_matrix_get(A[k],j,i));
-              //gsl_vector_complex_set(h, 2, gsl_complex_mul_imag(gsl_complex_add(gsl_matrix_complex_get(A[k],j,i), gsl_matrix_complex_get(A[k],i,j)),1));
-              
-              // Calculate G = Re[ \sum_k h^H (A^{(k)}) h(A^{(k)}) ]
-              for (l=0;l<2;l++)
-                for (m=0;m<2;m++)
-                    gsl_matrix_set(G,l,m, gsl_vector_get(h,l) * gsl_vector_get(h,m) + gsl_matrix_get(G,l,m));
-            }
-          
-            //fprintf(stderr,"(%i),(%i,%i) STEP 3b\n",P->Par.me,i,j);
-            // STEP 3b: retrieve eigenvector which belongs to greatest eigenvalue of G
-            gsl_eigen_symmv(G, eval, evec, w);  // calculates eigenvalues and eigenvectors of G
-        
-            index = gsl_vector_max_index (eval);  // get biggest eigenvalue
-            x = gsl_matrix_get(evec, 0, index);
-            y = gsl_matrix_get(evec, 1, index) * x/fabs(x);
-            //z = gsl_matrix_get(evec, 2, index) * x/fabs(x);
-            x = fabs(x);  // ensure x>=0 so that rotation angles remain smaller Pi/4
-          
-            //fprintf(stderr,"(%i),(%i,%i) STEP 3c\n",P->Par.me,i,j);
-            // STEP 3c: calculate R = [[c,s^\ast],[-s,c^\ast]]
-            r = sqrt(x*x + y*y); // + z*z);
-            c[0] = sqrt((x + r) / (2*r));
-            s[0] = y / sqrt(2*r*(x+r)); //, -z / sqrt(2*r*(x+r)));
-            //fprintf(stderr,"(%i),(%i,%i) COS %e\t SIN %e\n",P->Par.me,i,j,c[0],s[0]);
-          
-            //fprintf(stderr,"(%i),(%i,%i) STEP 3d\n",P->Par.me,i,j);
-            // STEP 3d: apply rotation R to rows and columns of A^{(k)}
-            for (k=0;k<max_operators+1;k++) {// one extra for B matrix !
-              for (l=0;l<AllocNum;l++) {
-                // Rows
-                a_i = gsl_matrix_get(A[k],i,l);
-                a_j = gsl_matrix_get(A[k],j,l);
-                gsl_matrix_set(A[k], i, l,  c[0] * a_i + s[0] * a_j);
-                gsl_matrix_set(A[k], j, l, -s[0] * a_i + c[0] * a_j);
-              }
-              for (l=0;l<AllocNum;l++) {
-                // Columns
-                a_i = gsl_matrix_get(A[k],l,i);
-                a_j = gsl_matrix_get(A[k],l,j);
-                gsl_matrix_set(A[k], l, i,  c[0] * a_i + s[0] * a_j);
-                gsl_matrix_set(A[k], l, j, -s[0] * a_i + c[0] * a_j);
-              }
-            }
-            //fprintf(stderr,"(%i),(%i,%i) STEP 3e\n",P->Par.me,i,j);
-            // STEP 3e: apply U = R*U
-            for (l=0;l<AllocNum;l++) {
-                a_i = gsl_matrix_get(U,i,l);
-                a_j = gsl_matrix_get(U,j,l);
-                gsl_matrix_set(U, i, l,  c[0] * a_i + s[0] * a_j);
-                gsl_matrix_set(U, j, l, -s[0] * a_i + c[0] * a_j);
-            }
-          }
-          // and merry-go-round for the indices too            
-          //debug(P,"and merry-go-round for the indices too");
-          if (AllocNum > 2) music(top, bot, AllocNum/2);
-        }
-       
-        //if(P->Call.out[ReadOut]) fprintf(stderr,"(%i) STEP 4\n",P->Par.me);
-        // STEP 4: calculate new variance: \sum_{ik} (A^{(k)}_ii)^2
-        old_spread = spread;
-        spread = 0;
-        for(k=0;k<max_operators;k++) {   // go through all self-adjoint operators
-          for (i=0; i < AllocNum; i++) {  // go through all wave functions
-              spread += pow(gsl_matrix_get(A[k],i,i),2);
-          }
-        }
-        if(P->Call.out[ReadOut]) fprintf(stderr,"(%i) STEP 5: %2.9e - %2.9e <= %lg ?\n",P->Par.me,old_spread,spread,R->EpsWannier);
-        else fprintf(stderr,"%2.9e\n",spread);
-        // STEP 5: check change of variance
-      } while (fabs(old_spread-spread) >= R->EpsWannier);
-      // end of iterative diagonalization loop: We have found our final orthogonal U!
-      gsl_vector_free(h);
-      gsl_matrix_free(G);
-      gsl_eigen_symmv_free(w);  
-      gsl_vector_free(eval);
-      gsl_matrix_free(evec);
-      Free(c, "bla");
-      Free(s, "bla");
-    }  
-    
-    if(P->Call.out[ReadOut]) {// && P->Par.me == 0) { 
-      //debug(P,"output total U");
-      fprintf(stderr,"(%i) U_tot = \n",P->Par.me);
-      for (k=0;k<Num;k++) {    
-        for (l=0;l<Num;l++)
-          fprintf(stderr,"%e\t",gsl_matrix_get(U,l,k));
-        fprintf(stderr,"\n");
-      }
-    }
-  }
-  Free(top, "bla");
-  Free(bot, "bla");
-
-  if(P->Call.out[ReadOut]) fprintf(stderr,"(%i) STEP 6: Allocating buffer mem\n",P->Par.me);
-  // STEP 6: apply transformation U to all wave functions \sum_i^Num U_ji | \phi_i \rangle = | \phi_j^\ast \rangle
-  Num = Psi->TypeStartIndex[type+1] - Psi->TypeStartIndex[type]; // recalc Num as we can only work with local Psis from here
-  fftw_complex **coeffs_buffer = Malloc(sizeof(fftw_complex *)*Num, "ComputeMLWF: **coeffs_buffer");
-  for (l=0;l<Num;l++) // allocate for each local wave function
-    coeffs_buffer[l] = LevS->LPsi->OldLocalPsi[l];
-  
-  if(P->Call.out[ReadOut]) fprintf(stderr,"(%i) STEP 6: Transformation ...\n",P->Par.me);
-  l=-1; // to access U matrix element (0..Num-1)
-  k=-1; // to access the above swap coeffs_buffer (0..LocalNo-1)
-  for (i=0; i < Psi->MaxPsiOfType+P->Par.Max_me_comm_ST_PsiT; i++) {  // go through all wave functions
-    OnePsiA = &Psi->AllPsiStatus[i];    // grab OnePsiA
-    if (OnePsiA->PsiType == type) {   // drop all but occupied ones
-      l++;  // increase l if it is occupied wave function
-      if (OnePsiA->my_color_comm_ST_Psi == P->Par.my_color_comm_ST_Psi) { // local?
-        k++; // increase k only if it is a local, non-extra orbital wave function
-        LPsiDatA = (fftw_complex *) coeffs_buffer[k];    // new coeffs first go to copy buffer, old ones must not be overwritten yet
-        SetArrayToDouble0((double *)LPsiDatA, 2*LevS->MaxG);  // zero buffer part
-      } else
-        LPsiDatA = NULL;  // otherwise processes won't enter second loop, though they're supposed to send coefficients!
-
-      m = -1; // to access U matrix element (0..Num-1)
-      for (j=0; j < Psi->MaxPsiOfType+P->Par.Max_me_comm_ST_PsiT; j++) {  // go through all wave functions
-        OnePsiB = &Psi->AllPsiStatus[j];    // grab OnePsiB
-        if (OnePsiB->PsiType == type) {   // drop all but occupied ones
-          m++;  // increase m if it is occupied wave function
-          if (OnePsiB->my_color_comm_ST_Psi == P->Par.my_color_comm_ST_Psi) // local?
-             LOnePsiB = &Psi->LocalPsiStatus[OnePsiB->MyLocalNo];
-          else 
-             LOnePsiB = NULL;
-          if (LOnePsiB == NULL) {   // if it's not local ... receive it from respective process into TempPsi
-            RecvSource = OnePsiB->my_color_comm_ST_Psi;
-            MPI_Recv( LevS->LPsi->TempPsi, LevS->MaxG*ElementSize, MPI_DOUBLE, RecvSource, WannierTag2, P->Par.comm_ST_PsiT, &status );
-            LPsiDatB=LevS->LPsi->TempPsi;
-          } else {                  // .. otherwise send it to all other processes (Max_me... - 1)
-            for (p=0;p<P->Par.Max_me_comm_ST_PsiT;p++)
-              if (p != OnePsiB->my_color_comm_ST_Psi) 
-                MPI_Send( LevS->LPsi->LocalPsi[OnePsiB->MyLocalNo], LevS->MaxG*ElementSize, MPI_DOUBLE, p, WannierTag2, P->Par.comm_ST_PsiT);
-            LPsiDatB=LevS->LPsi->LocalPsi[OnePsiB->MyLocalNo];
-          } // LPsiDatB is now set to the coefficients of OnePsi either stored or MPI_Received
-
-          if (LPsiDatA != NULL) {
-            double tmp = gsl_matrix_get(U,l,m);
-            g=0;
-            if (LevS->GArray[0].GSq == 0.0) {
-              LPsiDatA[g].re += LPsiDatB[g].re * tmp;
-              LPsiDatA[g].im += LPsiDatB[g].im * tmp;
-              g++;
-            }
-            for (; g < LevS->MaxG; g++) {
-              LPsiDatA[g].re += LPsiDatB[g].re * tmp;
-              LPsiDatA[g].im += LPsiDatB[g].im * tmp;
-            }
-          }
-        }
-      }
-    }
-  }
-  gsl_matrix_free(U);
-
-  if(P->Call.out[StepLeaderOut]) fprintf(stderr,"(%i) STEP 6: Swapping buffer mem\n",P->Par.me);
-  // now, as all wave functions are updated, swap the buffer
-  l = -1;
-  for (k=0;k<Psi->MaxPsiOfType+P->Par.Max_me_comm_ST_PsiT;k++) { // go through each local occupied wave function
-    if (Psi->AllPsiStatus[k].PsiType == type && Psi->AllPsiStatus[k].my_color_comm_ST_Psi == P->Par.my_color_comm_ST_Psi) {
-      l++;
-      if(P->Call.out[StepLeaderOut]) fprintf(stderr,"(%i) (k:%i,l:%i) LocalNo = (%i,%i)\t AllPsiNo = (%i,%i)\n", P->Par.me, k,l,Psi->LocalPsiStatus[l].MyLocalNo, Psi->LocalPsiStatus[l].MyGlobalNo, Psi->AllPsiStatus[k].MyLocalNo, Psi->AllPsiStatus[k].MyGlobalNo);
-      LPsiDatA = (fftw_complex *)coeffs_buffer[l];
-      LPsiDatB = LevS->LPsi->LocalPsi[l];
-      for (g=0;g<LevS->MaxG;g++) {
-        LPsiDatB[g].re = LPsiDatA[g].re;
-        LPsiDatB[g].im = LPsiDatA[g].im;
-      }
-      // recalculating non-local form factors which are coefficient dependent!
-      CalculateNonLocalEnergyNoRT(P, Psi->LocalPsiStatus[l].MyLocalNo);
-    }
-  } 
-  // and free allocated buffer memory
-  Free(coeffs_buffer, "bla");
-
-  if(P->Call.out[ReadOut]) fprintf(stderr,"(%i) STEP 7\n",P->Par.me);
-  // STEP 7: Compute Wannier centers, spread and printout
-  // the spread for x,y,z resides in the respective diagonal element of A_.. for each orbital
+        //PrintGSLMatrix(P,DiagData->U,DiagData->AllocNum, "U (after rot)");
+      }
+      // and merry-go-round for the indices too            
+      //debug(P,"and merry-go-round for the indices too");
+      if (DiagData->AllocNum > 2) MerryGoRoundIndices(DiagData->top, DiagData->bot, DiagData->AllocNum/2);
+    }
+   
+    //if(P->Call.out[ReadOut]) fprintf(stderr,"(%i) STEP 4\n",P->Par.me);
+    // STEP 4: calculate new variance: \sum_{ik} (A^{(k)}_ii)^2
+    old_spread = spread;
+    spread = 0.;
+    for(k=0;k<DiagData->NumMatrices;k++) {   // go through all self-adjoint operators
+      for (i=0; i < DiagData->AllocNum; i++) {  // go through all wave functions
+          spread += pow(gsl_matrix_get(DiagData->A[k],i,i),2);
+      }
+    }
+    if(P->Par.me == 0) {
+      //if(P->Call.out[ReadOut]) 
+      //  fprintf(stderr,"(%i) STEP 5: %2.9e - %2.9e <= %lg ?\n",P->Par.me,old_spread,spread,R->EpsWannier);
+      //else 
+        //fprintf(stderr,"%2.9e\n",spread);
+    }
+    // STEP 5: check change of variance
+  } while (fabs(old_spread-spread) >= R->EpsWannier);
+  // end of iterative diagonalization loop: We have found our final orthogonal U!
+  Free(c, "SerialDiagonalization: c");
+  Free(s, "SerialDiagonalization: s");
+  // free eigenvector stuff     
+  gsl_vector_free(h);
+  gsl_matrix_free(G);
+  //gsl_eigen_symmv_free(w);  
+  gsl_vector_free(eval);
+  gsl_matrix_free(evec);
+}
+
+/** Writes the wannier centres and spread to file.
+ * Also puts centres from array into OnePsiElementAddData structure.
+ * \param *P Problem at hand
+ * \param old_spread first term of wannier spread
+ * \param spread second term of wannier spread
+ * \param **WannierCentre 2D array (NDIM, \a Num) with wannier centres
+ * \param *WannierSpread array with wannier spread per wave function
+ */
+void WriteWannierFile(struct Problem *P, double spread, double old_spread, double **WannierCentre, double *WannierSpread)
+{
+  struct FileData *F = &P->Files;
+  struct RunStruct *R = &P->R;
+  struct Lattice *Lat = &P->Lat;
+  struct Psis *Psi = &Lat->Psi;
+  struct OnePsiElement *OnePsiA;
+  char spin[12], suffix[18];
+  int i,j,l;
+
   if(P->Call.out[ReadOut]) fprintf(stderr,"(%i) Spread printout\n", P->Par.me);
 
   switch (Lat->Psi.PsiST) {
   case SpinDouble:
-    strncpy(suffix,".spread.csv",18);    
-    strncat(spin,"SpinDouble",12);
+    strcpy(suffix,".spread.csv");    
+    strcpy(spin,"SpinDouble");
     break;
   case SpinUp:
-    strncpy(suffix,".spread_up.csv",18);    
-    strncat(spin,"SpinUp",12);
+    strcpy(suffix,".spread_up.csv");    
+    strcpy(spin,"SpinUp");
     break;
   case SpinDown:
-    strncpy(suffix,".spread_down.csv",18);    
-    strncat(spin,"SpinDown",12);
+    strcpy(suffix,".spread_down.csv");    
+    strcpy(spin,"SpinDown");
     break;
   }
